<?php
class Speedy_Speedyshipping_Block_Adminhtml_Requestcourier_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
    protected function _construct()
    {
        parent::_construct();

        $this->setId('BolGrid');
        $this->setDefaultSort('bol_datetime');
        $this->setDefaultDir('DESC');
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('speedyshippingmodule/saveorder')->getCollection()
            ->addFieldToFilter('bol_id', array('notnull' => true));

        $this->setCollection($collection);

        return parent::_prepareCollection();
    }

    protected function _prepareColumns()
    {
        $this->addColumn('bol_id', array(
            'header' => $this->__('View Bill of lading number'),
            'align'  => 'center',
            'width'  => '10px',
            'index'  => 'bol_id',
            'type'   => 'number'
        ));

        $this->addColumn('bol_created_at', array(
            'header'   => $this->__('Taking time courier'),
            'align'    => 'center',
            'index'    => 'bol_created_at',
            'width'    => '50px',
            'type'     => 'date',
            'filter'   => false,
            'sortable' => false,
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_created'
        ));

        $this->addColumn('bol_datetime', array(
            'header'   => $this->__('Time and creation date'),
            'align'    => 'center',
            'index'    => 'bol_datetime',
            'type'     => 'datetime',
            'width'    => '50px',
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_datecreated'
        ));

        $this->addColumn('delivery_date', array(
            'header'   => $this->__('Delivery date'),
            'align'    => 'center',
            'index'    => 'delivery_date',
            'type'     => 'datetime',
            'width'    => '100px',
            'filter'   => false,
            'sortable' => false,
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_deliverydate'
        ));

        $this->addColumn('image', array(
            'header'   => '',
            'align'    => 'center',
            'index'    => 'image',
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_cancelbutton',
            'filter'   => false
        ));

        if (!Mage::getStoreConfig('carriers/speedyshippingmodule/bring_to_office') || !Mage::getStoreConfig('carriers/speedyshippingmodule/choose_office')) {
            $this->addColumn('images', array(
                'header'   => '',
                'align'    => 'center',
                'index'    => 'images',
                'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_requestbutton',
                'filter'   => false
            ));
        }

        $this->addColumn('view_bol', array(
            'header'   => '',
            'align'    => 'center',
            'index'    => 'view_bol',
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_viewbol',
            'filter'   => false
        ));

        $this->addColumn('order', array(
            'header'   => '',
            'align'    => 'center',
            'index'    => 'order',
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_vieworder',
            'filter'  => false
        ));

        $this->addColumn('view_print_voucher', array(
            'header'   => '',
            'align'    => 'center',
            'index'    => 'view_print_voucher',
            'renderer' => 'speedyshippingmodule/adminhtml_requestcourier_renderer_viewprintvoucher',
            'filter'   => false
        ));

        return parent::_prepareColumns();
    }

    protected function _prepareMassaction()
    {
        if (!Mage::getStoreConfig('carriers/speedyshippingmodule/bring_to_office') || !Mage::getStoreConfig('carriers/speedyshippingmodule/choose_office')) {
            $this->setMassactionIdField('speedy_order_id');
            $this->getMassactionBlock()->setFormFieldName('speedy_order_id');

            $this->getMassactionBlock()->addItem('requestcourier', array(
                'label'   => $this->__('Request a courier'),
                'url'     => $this->getUrl('*/*/massRequest'),
                'confirm' => $this->__('Are you sure, that you want to make a couriter request')
            ));
        }

        return $this;
    }
}

